include FileRev.inc
include ../CmnHdr.inc
;**********************CODE SEGMENT*********************************
.code 
start:;START PROG HERE 
		invoke	InitCommonControls
		invoke	GetModuleHandle,NULL
		mov	hInstance,eax
		invoke	DialogBoxParam,hInstance,IDD_FILEREV,NULL,offset DlgProc,0
		invoke	ExitProcess,NULL

;***************File Reverse Function*******************************
FileReverse  proc uses edi pszPathname:dword,pfIsTextUnicode:dword
local hFile:DWORD
local dwFileSize:dword
local hFileMap:DWORD
local pvFile:dword
;local iUnicodeTestFlags:dword
	mov [pfIsTextUnicode],FALSE;Assume text is ANSI
	
	; Open the file for reading and writing.
	INVOKE CreateFile,pszPathname, GENERIC_WRITE or GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	mov hFile,eax
	
	.if eax==INVALID_HANDLE_VALUE
		chMB SADD("File could not be opened")
		xor eax,eax
		ret
	.endif
	
	; Get the size of the file (I assume the whole file can be mapped).
	invoke GetFileSize,hFile, NULL
	mov dwFileSize,eax
	
	;Create the file-mapping object. The file-mapping object is 1 character 
    ; bigger than the file size so that a zero character can be placed at the 
    ; end of the file to terminate the string (file). Because I don't yet know
    ; if the file contains ANSI or Unicode characters, I assume worst case
    ; and add the size of a WCHAR instead of CHAR.
	invoke CreateFileMapping,hFile, NULL, PAGE_READWRITE, 
      0, dwFileSize + sizeof WORD, NULL
	MOV hFileMap,eax
	
	.if eax == NULL
		chMB SADD("File map could not be opened.")
		invoke CloseHandle,hFile
		xor eax,eax
		ret
	.endif
	
	;Get the address where the first byte of the file is mapped into memory.
	invoke MapViewOfFile,hFileMap, FILE_MAP_WRITE, 0, 0, 0
	mov pvFile,eax
	
	.if eax == NULL
		chMB SADD("Could not map view of file.")
		invoke CloseHandle,hFileMap
		invoke CloseHandle,hFile
		xor eax,eax
		ret
	.endif

	;Does the buffer contain ANSI or Unicode?
	;mov iUnicodeTestFlags,-1;Try all tests
	;invoke IsTextUnicode,pvFile, dwFileSize, addr iUnicodeTestFlags
	
	xor eax,eax;we only do with ANSI now.
	.if !eax		
		;For all the file manipulations below, we explicitly use ANSI 
        ;functions because we are processing an ANSI file.

	.data
		pchANSI dd 0
	.code
		;Put a zero character at the very end of the file.
		push pvFile
		pop pchANSI
		xor edx,edx
		mov eax,dwFileSize
		mov ecx,sizeof BYTE
		div ecx
		mov edi,pchANSI
		add edi,eax
		xor eax,eax
		mov [edi],eax
		
		;Reverse the contents of the file.
		invoke _strrev,pchANSI		
		
		; Convert all "\n\r" combinations back to "\r\n" to 
        ;preserve the normal end-of-line sequence.
		invoke strchr,pchANSI,10; Find first '\n'.
		mov pchANSI,eax
		.while eax!=NULL
			;We have found an occurrence....
			mov byte ptr [eax],13; Change '\n' to '\r'.
			inc eax
			mov byte ptr [eax],10;Change '\r' to '\n'.
			inc eax
			invoke strchr,eax,10;Find the next occurrence.
		.endw				
	.else
		;Do with UNICODE Here.
	.endif
   
   ; Clean up everything before exiting.
   invoke UnmapViewOfFile,pvFile
   invoke CloseHandle,hFileMap

   ; Remove trailing zero character added earlier.
   invoke SetFilePointer,hFile, dwFileSize, NULL, FILE_BEGIN
   invoke SetEndOfFile,hFile
   invoke CloseHandle,hFile
   mov eax,TRUE
   ret
FileReverse endp

;***********DIALOG MESSAGE PROCEDURE*****************************
DlgProc	proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
		mov	eax,uMsg
		.if	eax == WM_CLOSE
			invoke	EndDialog,hWnd,NULL
		
		.elseif	eax == WM_INITDIALOG
			chSETDLGICONS hWnd,IDI_FILEREV;set dlg icon.
			
			invoke GetDlgItem,hWnd,IDC_REVERSE
			invoke EnableWindow,eax,FALSE
		.elseif	eax == WM_COMMAND
			mov	eax,wParam
			and eax,0ffffh
			.if eax == IDCANCEL 
				invoke	EndDialog,hWnd,NULL
			
			.elseif eax==IDC_FILENAME
				invoke GetDlgItem,hWnd,IDC_FILENAME
				invoke GetWindowTextLength,eax
				push eax
				invoke GetDlgItem,hWnd, IDC_REVERSE 
				pop ecx
				invoke EnableWindow,eax,ecx
				
			.elseif eax== IDC_REVERSE
				invoke GetDlgItemText,hWnd, IDC_FILENAME,addr szPathname,MAX_PATH
				
				;Make copy of input file so that we don't destroy it
				invoke CopyFile,addr szPathname,addr FILENAME, FALSE				
				.if eax == 0					
					chMB SADD("New file could not be created.")
					ret
				.endif
				
				invoke FileReverse,addr FILENAME, addr fIsTextUnicode				
				.if eax 
					.if fIsTextUnicode
						invoke SetDlgItemText,hWnd,IDC_TEXTTYPE,SADD("Unicode")						
					.else
						invoke SetDlgItemText,hWnd,IDC_TEXTTYPE,SADD("ANSI")
					.endif					
					;Spawn Notepad to see the fruits of our labors.					
					.data
						StartupInfo STARTUPINFO {0}
						pi PROCESS_INFORMATION  {0}
					.code
					invoke CreateProcess,NULL, SADD("Notepad FILEREV.DAT"),NULL, NULL, FALSE, 0, NULL, NULL, addr StartupInfo, addr pi
					.if eax !=0
						invoke CloseHandle,pi.hThread
                        invoke CloseHandle,pi.hProcess
					.endif
				.endif
			
			.elseif eax==IDC_FILESELECT
				mov ofn.lStructSize,sizeof ofn
				push hWnd
				pop ofn.hWndOwner
				push hInstance
				pop ofn.hInstance
				mov ofn.lpstrFile,offset szPathname
				mov ofn.lpstrTitle,CTXT("Select file for reversing")
				mov ofn.nMaxFile,MAX_PATH
				MOV ofn.Flags,OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST\
				OR OFN_LONGNAMES OR OFN_EXPLORER OR OFN_HIDEREADONLY
				invoke GetOpenFileName,addr ofn
				invoke SetDlgItemText,hWnd, IDC_FILENAME, ofn.lpstrFile
				invoke GetDlgItem,hWnd, IDC_REVERSE
				invoke SetFocus,eax
			.endif
		.else
			xor eax,eax
			ret
		.endif		   
		mov	eax,TRUE
		ret
		
DlgProc	endp
;********************************************************************

end	start
;**************************End of File*******************************